Botan 2.13.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::DataSink_Stream Class Referencefinal

`#include <data_snk.h>`

Inheritance diagram for Botan::DataSink_Stream:

## Public Member Functions
bool | attachable () override
| DataSink_Stream (std::ostream &stream, const std::string &name="<std::ostream>")
void | end_msg () override
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t[], size_t) override
| ~DataSink_Stream ()

## Protected Member Functions
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in)
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in, size_t length)

## Detailed Description

This class represents a data sink which writes its output to a stream.

Definition at line 35 of file data_snk.h.

## Constructor & Destructor Documentation

Botan::DataSink_Stream::DataSink_Stream | ( | std::ostream & | stream,
|  | const std::string & | name = `"<std::ostream>"`
| ) |  |

Construct a DataSink_Stream from a stream.

Parameters

  stream | the stream to write to
  name | identifier

Definition at line 42 of file data_snk.cpp.

43 :
44 m_identifier(name),
45 m_sink(out)
46 {
47 }
Botan::DataSink_Stream::name
std::string name() const override
Definition: data_snk.h:58

Botan::DataSink_Stream::~DataSink_Stream | ( |  | ) |

Definition at line 70 of file data_snk.cpp.

71 {
72 // for ~unique_ptr
73 }

## Member Function Documentation

bool Botan::DataSink::attachable | ( |  | ) |
| inline override virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented from Botan::Filter.

Definition at line 24 of file data_snk.h.

24 { return false; }

void Botan::DataSink_Stream::end_msg | ( |  | ) |
| override virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 34 of file data_snk.cpp.

35 {
36 m_sink.flush();
37 }

std::string Botan::DataSink_Stream::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 58 of file data_snk.h.

58 { return m_identifier; }

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Base64_Encoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::write(), and Botan::Hex_Decoder::write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 71 of file filter.h.

72 {
73 send(in.data(), in.size());
74 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

References BOTAN_ASSERT_NOMSG.

82 {
83 BOTAN_ASSERT_NOMSG(length <= in.size());
84 send(in.data(), length);
85 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
BOTAN_ASSERT_NOMSG
#define BOTAN_ASSERT_NOMSG(expr)
Definition: assert.h:68

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 { /* default empty */ }

void Botan::DataSink_Stream::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| override virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 23 of file data_snk.cpp.

References Botan::cast_uint8_ptr_to_char().

24 {
25 m_sink.write(cast_uint8_ptr_to_char(out), length);
26 if(!m_sink.good())
27 throw Stream_IO_Error("DataSink_Stream: Failure writing to " +
28 m_identifier);
29 }
Botan::cast_uint8_ptr_to_char
const char * cast_uint8_ptr_to_char(const uint8_t *b)
Definition: mem_ops.h:194

The documentation for this class was generated from the following files:

- src/lib/filters/data_snk.h
- src/lib/filters/data_snk.cpp